from typing import List, Tuple

Sample = Tuple[List[float], int]
SampleSet = List[Sample]

class Perceptron:
    @property
    def state(self) -> str: ...
    @property
    def dimensions(self) -> int: ...
    @property
    def data(self) -> List[Sample]: ...
    @property
    def model(self) -> List[float]: ...

    def __init__(self, dimensions: int, data: List[Sample] = []) -> None: ...

    def add_samples(self, data: List[Sample]) -> None: ...
    def replace_samples(self, data: List[Sample]) -> None: ...
    def replace_samples(self) -> None: ...
    def train(self, iterations: int, should_normalize: bool = True) -> List[float]: ...
    